# Creator : Sunkyeong Lee
# Inquiry : sunkyeong.lee@concentrix.com / sunkyong9768@gmail.com

import urllib.request
import json
from sqlalchemy import create_engine
import pandas as pd
import time

def getConversionData(company, start_date, end_date, site_code):
    
    api_key = ''
    url = 'https://api.similarweb.com/v1/segment/{company}/conversion-analysis/query?api_key={api_key}&start_date={start_date}&end_date={end_date}&country={site_code}&metrics=visits,converted-visits&channel=total&main_domain_only=false&format=json&show_verified=false'.format(company = company, api_key = api_key, start_date = start_date, end_date = end_date, site_code = site_code)

    response = urllib.request.urlopen(url)
    response_message = response.read().decode('utf8')

    return pd.DataFrame(json.loads(response_message)['segments'])


def stackTodb(dataFrame, dbTableName):
    print(dataFrame)
    db_connection_str = 'mysql+pymysql://root:12345@127.0.0.1:3307/similarweb'
    db_connection = create_engine(db_connection_str, encoding='utf-8')
    conn = db_connection.connect()

    dataFrame.to_sql(name=dbTableName, con=db_connection, if_exists='append', index=False)
    print("finished")


def websiteConverter(website):
    website_list = {'samsung' : 'samsung.com%23', 'apple' : 'apple.com%23', 'lg' : 'lg.com%23', 'currys' : 'currys.co.uk%23', 'amazon.uk mobile phone' : 'amazon.co.uk%23Mobile%20Phones%20and%20Communication', 'amazon.uk home appliances' : 'amazon.co.uk%23Kitchen%20and%20Home%20Appliances', 'hp' : 'hp.com%23', 'amazon.uk home cinema' : 'amazon.co.uk%23Home%20Cinema,%20TV%20and%20Video', 'dell' : 'dell.com%23', 'amazon cell phone' : 'amazon.com%23Cell%20Phones%20and%20Accessories', 'amazon electronics' : 'amazon.com%23Electronics', 'walmart' : 'walmart.com%23Electronics', 'amazon appliances' : 'amazon.com%23Appliances', 'bestbuy' : 'bestbuy.com%23'}
    return website_list[website]

def companyNameConverter(company):
    company_list = {'samsung' : 'samsung', 'apple' : 'apple', 'lg' : 'lg', 'currys' : 'currys', 'amazon.uk mobile phone' : 'amazon', 'amazon.uk home appliances' : 'amazon', 'hp' : 'hp', 'amazon.uk home cinema' : 'amazon', 'dell' : 'dell', 'amazon cell phone' : 'amazon', 'amazon electronics' : 'amazon', 'walmart' : 'walmart', 'amazon appliances' : 'amazon', 'bestbuy' : 'bestbuy'}
    return company_list[company]

# 22-01-14 추가
def siteCodeConverter(sitecode):
    sitecode_list = {'au' : 'au', 'br' : 'br', 'ca' : 'ca', 'fr' : 'fr', 'de' : 'de', 'in' : 'in', 'id' : 'id', 'it' : 'it', 'nl' : 'nl', 'ru' : 'ru', 'sa' : 'sa', 'es' : 'es', 'se' : 'se', 'tr' : 'tr', 'uk' : 'gb', 'ae' : 'ae', 'us' : 'us', 'eg' : 'eg'}
    return sitecode_list[sitecode]


def dataCaller(company, start_date, end_date, site_code):
    dataFrame = getConversionData(websiteConverter(company), start_date, end_date, siteCodeConverter(site_code))
    dataFrame.insert(0, "site_code", site_code, True)
    dataFrame.insert(1, "data_saved", time.strftime('%Y-%m-%d', time.localtime()), True)
    dataFrame.insert(2, "company_name", companyNameConverter(company), True)
    dataFrame.insert(3, "sub_company_name", company, True)

    return dataFrame

def SW_Conversion(company, start_date, end_date, site_code, dbTableName):
    for i in range(len(company)):
        for j in range(len(site_code)):
            while True:
                try:
                    stackTodb(dataCaller(company[i], start_date, end_date, site_code[j]), dbTableName)
            
                except urllib.error.HTTPError:
                    print('No Matching Data : {company} X {site_code}'.format(company = company[i], site_code = site_code[j]))

                break

# if __name__ == "__main__":

#     company = ['amazon.uk mobile phone', 'apple', 'samsung']
#     start_date = '2021-05'
#     end_date = '2021-09'
#     site_code = ['uk', 'us']
#     dbTableName = 'tb_conversion_test'

#     SW_Conversion(company, start_date, end_date, site_code, dbTableName)